﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Prohlizec_obrazku
{
    public partial class Form1 : Form
    {
        public string adresar = @".\";//zobrazeny adresar
        public int rezim = 0;//0 = prochazeni adresaru, 1 = zobrazeni obr
        public string obrazek = "";//zobrazeny obrazek
        public int index_obr = -1;//index zobrazeneho obrazku
        public float zoom = float.NaN;
        string[] atributy_obr;//vlastnosti (jmeno, rozliseni, velikost...) obrazku v adresari
        string[] jmena_obr;//cela cesta k obrazkum v adresari
        Graphics g;
        Bitmap[] prednactene;//prednactene obrazky


        public Form1(string[] args)
        {
            //bylo spusteno s nejakymi parametry?
            if (args.Length > 0)
            {
               
               
                //parametr byl soubor
                if (File.Exists(args[0]))
                {
                    string[] s = args[0].Split('.');
                    string ext = s[s.Length - 1].ToUpper();
                    //parametr byl obrazek
                    if (ext == "JPG" || ext == "JPEG")
                    {
                        rezim = 1;

                        this.NastavRezim1();
                        obrazek = args[0];
                        
                    }
                }
                //parametr byl adresar
                else if (Directory.Exists(args[0]))
                {
                    adresar = args[0];
                    rezim = 0;
                    this.NastavRezim0();
                }
            }
            InitializeComponent();
                       
            
            this.NactiAdresarovyStrom();
            this.NactiObrazky();
        }

        /// <summary>
        /// nacte adresarovou strukturu vsech logickych disku
        /// </summary>
        private void NactiAdresarovyStrom()
        {
            string[] drives = System.IO.Directory.GetLogicalDrives();
            int k = 0;
            foreach (string drive in drives)
            {
                //pridej disk do stromui
                this.treeView1.Nodes.Add(drive);
                this.treeView1.Nodes[k].Name = drive;
                //nacti vsechny slozky disku
                this.NactiSlozku(this.treeView1.Nodes[k], drive);
                k++;
            }
        }

        /// <summary>
        /// prida podslozky do adresaroveho stromu a rekurzivne zavola tuto metodu pro vsechny podslozky
        /// </summary>
        /// <param name="node">misto ve stromu, kam se pridavaji slozky</param>
        /// <param name="path">adresar</param>
        private void NactiSlozku(TreeNode node, string path)
        {
            try
            {
                string[] directories = Directory.GetDirectories(path);
                int k = 0;
                foreach (string dir in directories)
                {
                    string[] s = dir.Split('\\');
                    //nacti podslozku do stromu
                    node.Nodes.Add(s[s.Length - 1]);
                    node.Nodes[k].Name = dir;
                    this.NactiSlozku(node.Nodes[k], dir);
                    k++;
                }
            }
            catch (Exception) { }
        }

        /// <summary>
        /// nacte obrazky ve zvolene slozce
        /// </summary>
        private void NactiObrazky()
        {
            try
            {
                //inicializace promennych
                Image b = new Bitmap(101, 100);
                prednactene = new Bitmap[5];
                this.imageList1.Images.Clear();
                //najdi vsechny soubory ve slozce
                string[] files = Directory.GetFiles(adresar);
                atributy_obr = new string[files.Length];
                jmena_obr = new string[files.Length];
                int k = 0;
                foreach (string file in files)
                {
                    //ma soubor spravnou priponu?
                    string[] s = file.Split('.');
                    string ext = s[s.Length - 1].ToUpper();
                    b = Bitmap.FromFile(file);
                    if (ext == "JPG" || ext == "JPEG")
                    {
                        //pridej obrazek do image listu
                        this.imageList1.Images.Add(b);
                        jmena_obr[k] = file;

                        string[] s2 = file.Split('\\');
                        //nacti jeho vlastnosti
                        atributy_obr[k] = s2[s2.Length -1] + ", " + ", " + File.GetCreationTime(file).ToString() + ", " + b.Width + " x " + b.Height;
                        //prednacti prvni obrazek
                        if (k == 0)
                        {
                            prednactene[0] = (Bitmap)b;
                        }
                        k++;
                    }
                    
                }
                //prednacti posledni obrazek
                this.prednactene[4] = (Bitmap)b;
                Array.Resize(ref atributy_obr, k);
                Array.Resize(ref jmena_obr, k);
                this.VykresliNahledy();
            }
            catch (Exception e)
            {
                System.Threading.Thread.Sleep(100);
            }
        }

        /// <summary>
        /// vykresli nahledy obrazku ve zvolene slozce
        /// </summary>
        private void VykresliNahledy()
        {
            //nastaveni rozmeru picture box a panelu
            this.panel1.Location = new Point(222, 26);
            this.panel1.Size = new Size(this.Size.Width - 232, this.Size.Height - 90);
            this.pictureBox1.Size = new Size(this.Size.Width - 233, this.Size.Height - 91);
            //zjisteni poctu obrazku na sirku a vysku
            int sirka = this.pictureBox1.Size.Width / 206;
            if (sirka < 1)
                return;
            int vyska = this.imageList1.Images.Count / sirka;
            if (this.imageList1.Images.Count % sirka != 0) vyska++;
            //pokud je treba, zvec picture box
            if (vyska * 254 > this.pictureBox1.Size.Height)
            {
                this.pictureBox1.Size = new Size(this.Size.Width - 231, vyska * 254); ;
            }
            
            this.pictureBox1.Image = new Bitmap(this.pictureBox1.Size.Width, this.pictureBox1.Size.Height);
            g = Graphics.FromImage(this.pictureBox1.Image);
            g.Clear(Color.White);

            int s = 0;
            int v = 0;
            int k = 0;
            Font f = new Font("Times New Roman", 12);//font na popis obrazku

            foreach (Image obr in this.imageList1.Images)
            {
                //ramecek kolem obrazku
                g.DrawRectangle(Pens.Gray, s * 204, v * 254, 204, 252);
                //zjisti jakou vysku a sirku bude mit obrazek v nahledu
                int height = 200;
                int width = obr.Width * 200 / obr.Height;
                if (obr.Width > obr.Height)
                {
                    width = 200;
                    height = obr.Height * 200 / obr.Width;
                }
                //zobraz obrazek
                g.DrawImage(obr, s * 204 + 2 + (200 - width) / 2, v * 254 + 2 + (200 - height) / 2, width, height);
                //zobraz popisek
                g.DrawString(atributy_obr[k], f, Brushes.Black, new RectangleF(s * 204  + 2, v * 254 + 204, 200, 50));

                s++;
                if (s == sirka)
                {
                    s = 0;
                    v++;
                }
                k++;
            }
            this.pictureBox1.Refresh();
        }

        /// <summary>
        /// zobrazi, ci skryje komponenty pro rezim prohlizeni adresare
        /// </summary>
        void NastavRezim1() 
        {
            this.toolStripButton1.Visible = true;
            this.toolStripButton2.Visible = true;
            this.toolStripButton3.Visible = true;
            this.toolStripButton4.Visible = true;
            this.toolStripButton5.Visible = true;
            this.toolStripButton6.Visible = true;
            this.MaximizeBox = false;
            this.WindowState = FormWindowState.Maximized;
            this.treeView1.Visible = false;
        
        }
        /// <summary>
        /// zobrazi, ci skryje komponenty pro rezim prohlizeni obrazku
        /// </summary>
        void NastavRezim0() {
            this.toolStripButton1.Visible = false;
            this.toolStripButton2.Visible = false;
            this.toolStripButton3.Visible = false;
            this.toolStripButton4.Visible = false;
            this.toolStripButton5.Visible = false;
            this.toolStripButton6.Visible = false;
            this.MaximizeBox = true;
            this.treeView1.Visible = true;
        }

        /// <summary>
        /// vykresli obrazek pres celou obrazovku
        /// </summary>
        /// <param name="p">index v poli prednactenych obrazku, -1 = nacist z disku</param>
        void VykresliObrazek(int p)
        {
            //nastav panel a picture box
            this.panel1.Location = new Point(0, 26);
            this.panel1.Size = new Size(this.Size.Width, this.Size.Height - 76);
            this.pictureBox1.Size = this.panel1.Size;
            this.pictureBox1.Image = new Bitmap(this.pictureBox1.Size.Width, this.pictureBox1.Size.Height);
            g = Graphics.FromImage(this.pictureBox1.Image);
            g.Clear(Color.Gray);
            Bitmap bmp;
            
            if (p > -1)
            {
                //nacti obrazek z prednactenych
                bmp = prednactene[p];
            }
            else
                //nacti obrazek z disku
                bmp = (Bitmap)Bitmap.FromFile(this.obrazek);
            int width;
            int height;
            //neni urcen zoom -> zobraz pres celou obrazovku
            if (float.IsNaN(zoom))
            {
                width = this.pictureBox1.Size.Width;
                zoom = this.pictureBox1.Size.Width / (float)bmp.Width;
                height = (int)(bmp.Height * zoom);

                if (zoom > this.pictureBox1.Size.Height / (float)bmp.Height)
                {
                    height = this.pictureBox1.Size.Height;

                    zoom = this.pictureBox1.Size.Height / (float)bmp.Height;
                    width = (int)(bmp.Width * zoom);
                }
            }
            else
            {
                //zobraz podle zoomu
                width = (int)(bmp.Width * zoom);
                height = (int)(bmp.Height * zoom);
                if (width > this.pictureBox1.Size.Width || height > this.pictureBox1.Size.Height)
                {
                    this.pictureBox1.Size = new Size(width, height);
                }
            }
            //zobraz obrazek
            g.DrawImage(bmp, (this.pictureBox1.Size.Width - width) / 2, (this.pictureBox1.Size.Height - height) / 2, width, height);
            this.pictureBox1.Refresh();
            //uloz do prednactenych aktualni obrazek
            this.prednactene[2] = bmp;
            //zobraz vlastnosti obrazku
            this.statusStrip1.Text = atributy_obr[index_obr] + ", zoom:" + ((int)Math.Floor(zoom + 100)).ToString() + ", " + (this.index_obr + 1).ToString() + "/" + this.jmena_obr.Length;
            //nacti predchozi a nasledujici
            if (index_obr > 0)
            {
                this.prednactene[1] = (Bitmap)Bitmap.FromFile(jmena_obr[index_obr - 1]);
            }
            if (index_obr < jmena_obr.Length - 1)
            {
                this.prednactene[3] = (Bitmap)Bitmap.FromFile(jmena_obr[index_obr + 1]);
            }
        }

        /// <summary>
        /// zmena adresare
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void treeView1_Click(object sender, EventArgs e)
        {
            
            adresar = this.treeView1.SelectedNode.Name;
            this.NactiObrazky();
        }

        /// <summary>
        /// podle rezimu zavola metodu, ktera vykresli potrebne
        /// </summary>
        void VykresliRezim()
        {
            if (rezim == 0)
                this.VykresliNahledy();
            else if (rezim == 1)
                this.VykresliObrazek(-1);
        }

        

        /// <summary>
        /// zmena rozmeru okna v rezimu prohlizeni adresare -> prekresli 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Resize(object sender, EventArgs e)
        {
            if (rezim == 0)
            {
                if (this.Size.Width < 300)
                {
                    this.Size = new Size(300, this.Size.Height);
                }
                this.VykresliRezim();
            }
        }

        //souradnice mysi na picture boxu
        int mx;
        int my;

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            mx = e.X;
            my = e.Y;
        }

        private void pictureBox1_DoubleClick(object sender, EventArgs e)
        {
            if (rezim == 0)
            {
                //zjisti pozici, kam se kliklo
                int sirka = this.pictureBox1.Size.Width / 206;
                int s = mx / 206;
                int v = my / 254;
                int index = s + v * sirka;
                if (index >= jmena_obr.Length || s >= sirka)
                {
                    return;
                }
                //prejdi do druheho rezimu a zapamatuj si, na ktery obrazek se kliklo
                this.index_obr = index;
                this.obrazek = jmena_obr[index];
                this.zoom = float.NaN;
                this.rezim = 1;
                this.NastavRezim1();
            }
            else if (rezim == 1)
            {
                rezim = 0;
                this.NastavRezim0();
            }
            this.VykresliRezim();
        }
        //jaky je oznaceny
        int s_oznaceny = -1;
        int v_oznaceny = -1;
        
        /// <summary>
        /// kliknuto na picture box - zjisti, jestli se v rezimu prohlizeni adresare nema oznacit obrazek
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void pictureBox1_Click(object sender, EventArgs e)
        {
            try
            {
                if (rezim == 0)
                {
                    //odznac predchozi oznaceny
                    if (s_oznaceny != -1)
                        g.DrawRectangle(Pens.Gray, s_oznaceny * 204, v_oznaceny * 254, 204, 252);
                    //zjisti pozici, kam se kliklo
                    int sirka = this.pictureBox1.Size.Width / 206;
                    int s = mx / 206;
                    int v = my / 254;
                    int index = s + v * sirka;
                    //nekliklo se mimo ?
                    if (index >= jmena_obr.Length || s >= sirka)
                    {
                        return;
                    }
                    //oznac obrazek
                    this.index_obr = index;
                    g.DrawRectangle(Pens.Red, s * 204, v * 254, 204, 252);

                    this.v_oznaceny = v;
                    this.s_oznaceny = s;
                    this.pictureBox1.Refresh();
                }
            }
            catch (Exception) { }
        }
        //ovladani klavesami
        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar.ToString() == Keys.Enter.ToString())
            {
                if (rezim == 0 && index_obr > -1)
                {
                    this.obrazek = jmena_obr[this.index_obr];
                    this.zoom = float.NaN;
                    this.rezim = 1;
                    this.NastavRezim1();
                    this.VykresliRezim();
                }
                else if (rezim == 1)
                {
                    rezim = 0;

                    this.NastavRezim0();
                    this.VykresliRezim();
                }
            }
            else if (e.KeyChar.ToString() == Keys.Escape.ToString())
            {
                Application.Exit();
            }
            else if (e.KeyChar.ToString() == Keys.Home.ToString() && rezim == 1)
            {
                this.index_obr = 0;
                this.VykresliObrazek(0);
            }
            else if (e.KeyChar.ToString() == Keys.End.ToString() && rezim == 1)
            {
                this.index_obr = this.jmena_obr.Length - 1;
                this.VykresliObrazek(4);
            }
            else if (e.KeyChar.ToString() == Keys.PageUp.ToString() && rezim == 1 && this.index_obr > 0)
            {
                index_obr--;
                this.VykresliObrazek(1);
            }
            else if (e.KeyChar.ToString() == Keys.PageDown.ToString() && rezim == 1 && this.index_obr < this.jmena_obr.Length - 1)
            {
                this.index_obr++;
                this.VykresliObrazek(3);
            }
            else if (e.KeyChar.ToString() == Keys.Oemplus.ToString() && rezim == 1 && zoom < 100f)
            {
                zoom += 0.1f;
                this.VykresliObrazek(2);
            }
            else if (e.KeyChar.ToString() == Keys.OemMinus.ToString() && rezim == 1 && zoom > 0.1f)
            {
                zoom -= 0.1f;
                this.VykresliObrazek(2);
            }
            else if (e.KeyChar.ToString() == Keys.Multiply.ToString() && rezim == 1)
            {
                zoom = 1;
                this.VykresliObrazek(2);
            }
            else if (e.KeyChar.ToString() == Keys.Divide.ToString() && rezim == 1)
            {
                zoom = float.NaN;
                this.VykresliObrazek(2);
            }
        }

        /// <summary>
        /// tlacitko ukoncit program
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton7_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        /// <summary>
        /// tlacitko priblizit
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton6_Click(object sender, EventArgs e)
        {
            if (rezim == 1 && zoom < 100f)
            {
                zoom += 0.1f;
                this.VykresliObrazek(2);
            }
        }

        /// <summary>
        /// tlacitko oddalit
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton5_Click(object sender, EventArgs e)
        {
            if (rezim == 1 && zoom > 0.1f)
            {
                zoom -= 0.1f;
                this.VykresliObrazek(2);
            }
        }

        /// <summary>
        /// tlacitko posledni
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            if (rezim == 1)
            {
                this.index_obr = this.jmena_obr.Length - 1;
                this.VykresliObrazek(4);
            }
        }

        /// <summary>
        /// tlacitko nasledujici
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            if (rezim == 1 && this.index_obr < this.jmena_obr.Length - 1)
            {
                this.index_obr++;
                this.VykresliObrazek(3);
            }
        }

        /// <summary>
        /// tlacitko predchozi
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            if (rezim == 1 && this.index_obr > 0)
            {
                this.index_obr--;
                this.VykresliObrazek(1);
            }
        }

        /// <summary>
        /// tlacitko prvni
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            if (rezim == 1)
            {
                this.index_obr = 0;
                this.VykresliObrazek(0);
            }
        }
    }
}
